// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* Handle.h               & XMM Science Analysis System (SAS) 
* 
* Class representing a Handle to an object.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: Handle.h,v 1.3 2008/09/26 16:38:55 eojero Exp $ 
* 
*****************************************************************/ 

#ifndef Handle_H
#define Handle_H


template<class T>
class Handle {
public :
	Handle() : _addressOfObject( (const T *)0 ) {};
	Handle(const T *addressOfObject) : _addressOfObject(addressOfObject) {}
	Handle(const T & object) : _addressOfObject(&object) {}

	T * addressOfObject() const {
		return (T *)_addressOfObject;
	}

private:
	const T *_addressOfObject;
};

#endif

