// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//						(c) 1998 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	NAN.h--- defines the NotANumber class that represents the ieee NaN.
//
//	DESCRIPTION:
//
//		bool isSet(float&) const;
//			// Detemines if a float is NaN.
//
//		bool isSet(float&) const;
//			// Detemines if a double is NaN.
//
//		bool isSet(const float&) const;
//			// Set a float to NaN.
//
//		bool isSet(const double&) const;
//			// Set a double to NaN.
//
//
//	USAGE EXAMPLES:
//
//	CHANGE HISTORY:
//		MT, 1998-10-01: 0.1.0: - first version
//
//	AUTHOR:
//		M.Thomas
//
//	REFERENCES:
//
//	$Header: /sasbuild/repositories/sasdev/sas/packages/utils/src/NAN.h,v 1.2 2008/09/26 16:38:55 eojero Exp $
///
#ifndef __NAN_H
#define __NAN_H


class NotANumber
{
	public :
		void set( float& ) const;
		void set( double& ) const;
		bool isSet( const float& ) const;
		bool isSet( const double& ) const;

};

extern NotANumber NaN;


#endif

