// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//					   (c) 1997 - 2010 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	SimpleToken.h	--- defines the SimpleToken class which represents
//                          basic tokens.
//
//	DESCRIPTION:
//
//	USAGE EXAMPLES:
//
//	CHANGE HISTORY:
//
//	AUTHOR:
//		M.Thomas
//
//	REFERENCES:
//
//	$Header: /sasbuild/repositories/sasdev/sas/packages/utils/src/SimpleToken.h,v 1.7 2008/09/26 16:38:55 eojero Exp $
///

#ifndef SIMPLE_TOKEN_H
#define SIMPLE_TOKEN_H

#include <string>
#include <cstdlib>

class SimpleTokenValue;

class SimpleToken
{
	public:
		enum Id {
				Undefined,	// None
				Character,	// char
				String,		// String
				Eof };		// None
		SimpleToken();
		SimpleToken( char v );
		SimpleToken( const std::string& v );
		SimpleToken( Id id );
		SimpleToken& operator=( const SimpleToken& );
		SimpleToken( const SimpleToken& );

		~SimpleToken();

		Id id() const;
		std::string idAsString() const;
		void id( Id id );
		void value( char v );
		void value( const std::string& v );
		char asChar() const;
		std::string asString() const;

		SimpleToken& operator=( char v );
		SimpleToken& operator=( const std::string& v );
		SimpleToken& operator=( Id id );

  //protected :

	private :
		SimpleTokenValue* 	_value;
		Id	_id;

};

#endif

