! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program randtest
    use Random
    implicit none

    integer i
    real(kind=double) d

    call SAS_randSetMinMaxRange(-20.d0, 100.d0, CLOSED)
    write(*, *) 'Seed is: ', SAS_randSeed()
    do i=1, 1000
        d=SAS_rand()
        if (d<-20.d0 .or. d > 100.d0) &
            stop 'randf90 - out of bounds 1'
    enddo

    call SAS_randPushState(200.d0, 300.d0, CLOSED)
    do i=1, 1000
        d=SAS_rand()
        if (d<200.d0 .or. d > 300.d0) &
            stop 'randf90 - out of bounds 2'
    enddo

    call SAS_randPopState()
    do i=1, 1000
        d=SAS_rand()
        if (d<-20.d0 .or. d > 100.d0) &
            stop 'randf90 - out of bounds 1'
    enddo
    write(*, *) 'Min/Max:', SAS_randMin(), SAS_randMax()

end program
