// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include<cassert>
#include "SimpleScanner.h"

#include <iostream>

static std::string
parseName( const std::string& name )
{
	SimpleScanner		sc( name, ":%" );
	std::string			parsedName;

	parsedName = name;
	parsedName = sc.match( SimpleToken::String ).asString();

	return parsedName;
}


int
main()
{
	const std::string	name = "TheName";
	std::string  parsedName;

	for( unsigned int i = 0; i < 50; ++i )
	{
		parsedName = parseName( name );
		assert( parsedName == name );
	} // for
}


